package KeyFramer;

public class script
{
	// private variables
	private String myWorkingPath = "";
	private String myPathToScript = "";
	private String myPathToSource = "";
	private int myStartingFileNumber = 100;
	private String myPOVFileName;
	private int myTotalFrameCount = 0;
	public animationPoints myAnimationPoints = new animationPoints();
	
	
	// contructor
	public script(String workingPath)
	{
		myWorkingPath = workingPath;
		myPathToScript = workingPath + "\\Script.kfs";
		boolean cont = true;
		
		cont = loadScript();
		
	}
	
	// loads the script file
	private boolean loadScript()
	{
		boolean returnValue = true;
		
		// does the script file exist?
		if(!fileHandling.DoesFileExist(myPathToScript))
		{
			System.out.println("The Script.scr file does not exist. ");
			return false;
		}
		
		// open the script file
		fileHandling myFH = new fileHandling();
		myFH.OpenFileForReading(myPathToScript);
		
		// read in the script file line by line
		String line = "";
		while(line != null)
		{
			if(line.trim() == "")
			{
				// do nothing , its blank line afterall.
			}
			else
			{
				if(line.startsWith("SOURCE:"))
				{
					// this line identifies the POV source File
					String[] parts = line.split(":");
					myPOVFileName = parts[1];
					myPathToSource = myWorkingPath + "\\" + myPOVFileName;
				}
				if(line.startsWith("FILENUMBER:"))
				{
					// this line specifies the starting number for the output files 
					String[] parts = line.split(":");
					myStartingFileNumber = Integer.parseInt(parts[1]);
				}
				if(line.startsWith("FRAMES:"))
				{
					// this line specifies the number of frames to generate 
					String[] parts = line.split(":");
					myTotalFrameCount = Integer.parseInt(parts[1]);
				}
				if(line.startsWith("ANIMATIONPOINT:"))
				{
					// this line specifies an animation point 
					myAnimationPoints.addAnimationPoint(new animationPoint(line));
				}
			}
			line = myFH.ReadLineFromFile();
		}
		myFH.CloseOpenedFile();
		return returnValue;
	}
	
	// parse the line for each animation point
	public String processLine(String line,int frame)
	{
		String returnValue = line;
		
		for(int i = 0 ; i < myAnimationPoints.getCount() ; i++)
		{
			returnValue = myAnimationPoints.getAnimationPointByIndex(i).processLine(returnValue,frame);
		}
		
		return returnValue;
	}

	
	// property accessors
	public int getFrameCount()
	{
		return myTotalFrameCount;
	}
	
	public String getSourceFile()
	{
		return myPathToSource;
	}
	
	public int getStartingFileNumber()
	{
		return myStartingFileNumber;
	}
	
}
